﻿using System;
using HeuristicLab.Common;
using HeuristicLab.Core;
using HeuristicLab.Data;

namespace HeuristicLab.Problems.MetaOptimization {
  public interface IRange : IItem, IStringConvertibleValue {
    object LowerBound { get; set; }
    object UpperBound { get; set; }
    object StepSize { get; set; }

    event EventHandler LowerBoundChanged;
    event EventHandler UpperBoundChanged;
    event EventHandler StepSizeChanged;

    IItem GetRandomValue(IRandom random);
  }

  public interface IRange<T> : IRange, IItem where T : class {
    new T LowerBound { get; set; }
    new T UpperBound { get; set; }
    new T StepSize { get; set; }
    new T GetRandomValue(IRandom random);
  }
}